<?php

namespace App\Modules\PaxInformationRoom\Application\Delete;

use App\Http\History\HistoryTables;
use App\Modules\PaxInformationRoom\Application\Index\IndexPaxInformationRoomPopulate;
use App\Modules\PaxInformationRoom\Domain\IdPaxInformationRoom;
use App\Modules\PaxInformationRoom\Domain\IndexPaxInformationRoom;
use App\Modules\PaxInformationRoom\Domain\PaxInformationRoomRepository;
use App\Modules\History\Application\Insert\InsertHistoryQuery;
use App\Modules\History\Domain\HistoryOperation;
use App\Modules\Room\Application\DeleteFromPaxInformation\DeleteFromPaxInformationRoomQuery;
use App\Modules\Shared\Domain\Bus\Event\EventBus;
use App\Modules\Shared\Domain\Bus\Query\QueryBus;
use App\Modules\Shared\Domain\Transaction;
use App\Modules\Versioner\Application\Check\VersionChecker;

final class PaxInformationRoomDeleter
{
    public function __construct(
        private PaxInformationRoomRepository $repository,
        private VersionChecker $versionChecker,
        private EventBus $eventBus,
        private QueryBus $queryBus,
        private Transaction $transaction
    ) {}

    public function __invoke(
        IdPaxInformationRoom $id,
        int $idAdmin
    ) {
        $this->transaction->begin();
        $index = $this->repository->find(new IndexPaxInformationRoom($id, new IndexPaxInformationRoomPopulate('')));
        $lastData = $index->toArray();
        $index->delete();
        $index->updateVersion();
        $index->updateDateUpdate();
        $this->repository->update($index);
        $this->queryBus->ask(new DeleteFromPaxInformationRoomQuery($index->id()->value()));
        // $index->addUpdatedDomainEvent($idAdmin);
        // $this->eventBus->publishAll(...$index->pullDomainEvents());
        $this->queryBus->ask(new InsertHistoryQuery(
            json_encode([$lastData]),
            json_encode([]),
            HistoryOperation::DELETE,
            $index->id()->value(),
            $index->id()->value(),
            HistoryTables::PAX_INFORMATION_ROOM,
            $idAdmin,
        ));
        $this->transaction->commit();
    }
}
